; Some test firmware
stackpointer equ $1FFFC
     dc.l stackpointer
     dc.l start
;    code

CR	equ	$0D
LF	equ	$0A
BACKSPACE_KEY	equ	$7F
BACKSPACE	equ	8
SPACE	equ	$20
CTRLC	equ	3
    
    include	"byteio_fast.asm"
;    include	"byteio_avr.asm"

    include	"srecord.asm"
; Start point - same as warm, bit outputs (c) message. Stack pointer
; assumed to be inited from (0)
start:
    move.b	d0,($E0000) ; switching clock fast
    lea.l	hellomsg,a0
    bsr	tx_str

; warm start. bra here to return.
warm:
    movea.l	#stackpointer,sp
loop2:

    movea.l	#promptmsg,a0 ;outputting prompt
    bsr	tx_str
    movea.l	#buff,a0 ; getting string
    move.w	#100,d0  ; to buff , size 10
    bsr	rx_str
    movea.l	#buff,a0 ; is string empty?
    move.b	(a0),d0
    beq	loop2

;    movea.l	#buff,a0
;    bsr	tx_str
    bsr	cmdexecute  	; try to decode command

    bra	loop2


; Compare buffer to a known command
cmdexecute:
    movea.l	#commands,a0	; loading the dictionary into A0
    movea.l	#commands_vector,a4 ; loading the vector pointer
cmdexecuteloop:
    movea.l	#buff,a1	; for every next command in dictionary, compare with the start of buffer
    cmpi.b	#$0,(a0)	; Commands ended?
    bne	cmdexecnextcmd	; check for next command
    movea.l	#errmsg,a0	; Yes, no more commands ; unknown command message
    bsr		tx_str
    movea.l	#buff,a0	; .. and the buffer itself
    bsr	tx_str
;   move.b	d0,($C0000)
    rts

cmdexecnextcmd:
    movea.l	a0,a3	; saving pointer to the currenly examined command

cmdexecloop2:
    move.b	(a0)+,d0	; take current char from command from the commands table
    beq	cmdexecdo		; the command ended - and if it was equal to buffer - executing it
    move.b	(a1)+,d1
    cmp.b	#$7a,d1	;'z'
    bgt		cmdexecnotuppercase
    cmp.b	#$61,d1	;'a'
    blt.b	cmdexecnotuppercase
    subi.b	#$20,d1		; uppercasing
cmdexecnotuppercase:
    cmp.b	d1,d0
; WAS    cmp.b	(a1)+,d0	; repat until buffer and command are equal
    beq	cmdexecloop2
				; if we got here, the command is not equal to buffer
cmdrewindtoendofcommand:	; rewinding command dictionary to the end of command
    cmpi.b	#$0,(a0)+
    bne	cmdrewindtoendofcommand

    adda.w	#$4,a4		; incrementing pointer to a function
    bra	cmdexecuteloop		; try to compare with next command

cmdexecdo:
;    movea.l	#executing_msg,a0
    ;bsr	tx_str

    movea.l	#crlfmsg,a0
    bsr	tx_str

;    movea.l	a3,a0		; a3 points to the dictionary - start of command
;    bsr	tx_str

;    move.b	d0,($E0000)
;    move.l	a4,-(sp)	; a4 is calculated subrotine address
;
;    move.l	(a4),d0
;    bsr	tx_l
    move.l	(a4),a0		; and a1 is pointing to the end of the buffer (after command)
    jmp.l	(a0)
;    move.l	a4,-(sp)	; a4 is calculated subrotine address
    rts				; jumps there - it should  rts to main loop
;    rts

;    move.w	(a4),d0
;    bsr	tx_w
;    adda	#$2,a4
;    move.w	(a4),d0
;    bsr	tx_w
;    rts
    

;------------------------ Commands----------------------------------

fuckaduck:	; a1 points to the buffer after the command
    move.l	#quackmsg,a0
    bsr	tx_str
    move.l	a1,a0
    bsr	scan_hex_string
    bsr	tx_l
    rts

f_blink:
    move.b	#$ff,($80000)

    move.l	#$10000,d1
f_blink1:
    subi.l	#1,d1
    bne		f_blink1

    move.b	#$00,($80000)

    move.l	#$10000,d1
f_blink2:
    subi.l	#1,d1
    bne		f_blink2

    bsr	rx_notempt
    beq	f_blink
    bsr	rx_char
    rts

f_ledon:
    move.b	#$ff,($80000)
    rts

f_ledoff:
    move.b	#$00,($80000)
    rts

f_in:
    move.b	($80000),d0
    andi.b	#$01,d0
    addi.b	#'0',d0
    bsr	tx_char
    rts

; blink fast
f_bf:
    move.b	d0,($E0000)
    move.w	#$800,d0
f_bf0:
    move.b	#$80,d1
f_bf1:
    move.b	d1,($20000)
    subi.b	#1,d1
    bne		f_bf1

    move.b	#$80,d1
f_bf2:
    subi.b	#1,d1
    bne		f_bf2
    
    subi.w	#$1,d0
    bne		f_bf0
    move.b	d0,($C0000)
    rts

; blink slowly ; 8000 times
f_bs:
    move.w	#$100,d0
f_bs0:
    move.b	#$80,d1
f_bs1:
    move.b	d1,($20000)
    subi.b	#1,d1
    bne		f_bs1

    move.b	#$80,d1
f_bs2:
    subi.b	#1,d1
    bne		f_bs2
    
    subi.w	#$1,d0
    bne		f_bs0
    rts


; dump
; take the address from command line, or from dumpstart
f_dump:
    move.b	(a1),d0 ; any address specified?
    beq	f_dump_default_addr

    move.l	a1,a0
    bsr	scan_hex_string	; d0 holds the start of dump
    bra	f_dump_got_addr

f_dump_default_addr:
    move.l	(dumpstart),d0

f_dump_got_addr: ; a1 is address to start dump
    move.l	d0,a1
    move.b	#$10,d2 ; $10 lines

f_dump_loop_0:
    movea	#crlfmsg,a0
    bsr	tx_str
    move.l	a1,d0	; showing address we dump from
    bsr	tx_l	
    move.b	#$20,d0
    bsr	tx_char
    move.b	#$10,d1 ; $10 lines
    movea	#f_dump_buf,a3
;    move.l	a1,a0
f_dump_loop_1:
    move.b	(a1)+,d0
    bsr	tx_b
    cmpi.b	#$20,d0
    bgt		f_dump_loop_1a ; is byte printable?
    move.b	#'.',d0
f_dump_loop_1a:
    move.b	d0,(a3)+
    move.b	#$20,d0
    bsr	tx_char
    subi.b	#$1,d1
    bne	f_dump_loop_1  ; showing line loop - done
    movea	#f_dump_buf_min_1,a0
    bsr	tx_str		; showing line as ascii
    subi.b	#$1,d2
    bne	f_dump_loop_0 ; next line

    move.l	a1,d0
    move.l	d0,(dumpstart) ; saving address
    rts
f_dump_buf_min_1:
    dc.b ' '
f_dump_buf:
    dc.b '0123456789abcdef',0

    even

; input: a0
; output:
; a1 = 1 - not a hex char
; a1 = 0 - is a hex char
;  a0 - 0-f

char_is_hex:
    andi.l	#$ff,d0
    cmpi.b	#$30,d0
    blt	char_is_hex_no
    cmpi.b	#$40,d0
    ble	char_is_hex_1	; 30-40 - '0'-'9'
    andi.b	#$df,d0	; it it's a lowercase - map to uppercase
    cmpi.b	#$41,d0 ; less then 'A'?
    blt	char_is_hex_no
    cmpi.b	#$46,d0	; more then 'F'?
    bgt	char_is_hex_no
    subi.b	#55,d0	; yes, 55 dec
    bra 	char_is_hex_yes

char_is_hex_1:
    subi.b	#$30,d0
    bra 	char_is_hex_yes

char_is_hex_yes
    move.b	#0,d1
    rts
    
char_is_hex_no:
    move.b	#1,d1
    rts

; input A0 - pointer to string
; output D0 - hex (up to long)
scan_hex_string:
    move.l	#0,d2
scan_hex_string_1:
    move.b	(a0)+,d0
    bsr 	char_is_hex
;    cmpi.b	#0,d1
    bne	scan_hex_string_end
    lsl.l	#4,d2
    add.l	d0,d2
    bra 	scan_hex_string_1

scan_hex_string_end:
    move.l	d2,d0
    suba.l	#1,a0
    rts


;----------------------string in and string out functions---------------
; drop it, use scan_hex_string
;
; gets byte from (A0) ; increments A0 by 2; returns in D0; no error checking
scan_b:
    move.l	d1,-(sp)
    move.b	(a0)+,d0
    subi.b	#$30,d0	; pointer - '0'
    cmpi.b	#$0a,d0
    blt	scan_b_1	; less then 'A'
;    subi.b	($41-$30-$0a),d0	; sub 'A' - 10
    andi.b	#$df,d0	; lowercasing
    subi.b	#$7,d0
scan_b_1:
    move.b	(a0)+,d1
    subi.b	#$30,d1	; pointer - '0'
    cmpi.b	#$0a,d1
    blt	scan_b_2	; less then 'A'
;    subi.b	#55,d1	; sub 'A' - 10
    andi.b	#$df,d1	; lowercasing
    subi.b	#$7,d1
scan_b_2:
;    rol	#4,d0
    lsl	#4,d0
    add.b	d1,d0
    andi.l	#$000000ff,d0
    move.l	(sp)+,d1
    rts

scan_w:
      move.l	d4,-(sp)
      move.l	#0,d0
      bsr	scan_b
      lsl.l	#8,d0
      move.l	d0,d4	; high byte
      bsr	scan_b
      add.l	d4,d0
      move.l	(sp)+,d4
      rts

;------------------ RX str int A0; length in word D0
rx_str:
    move.b	#$0,(a0)
    move.w	#$0,d1	; current char pointer
    move.w	d0,d2
rx_str_loop:
    bsr	rx_char
;    move.b	d0,(uartstat)
    cmp.b	#CR,d0
    beq	rx_str_exit
    cmp.b	#LF,d0
    beq	rx_str_exit
    cmp.b	#BACKSPACE_KEY,d0
    beq	rx_str_bs
    cmp.b	#SPACE,d0	;got not printable char
    blt	rx_str_loop


    bsr	tx_char		; regular char
    move.b	d0,(a0)+	;storing next character to a0
    move.b	#$0,(a0) ; writing eostring to a0
    addi	#$1,d1 ; incrementing current char pointer
;    move.b	d1,(uartstat)
;   move.b	d2,(uartstat)

    cmp.w	d1,d2 ; full?
    bne	rx_str_loop ; go again

rx_str_exit:
    move.b	#$0,(a0)
;    movea.l	#crlfmsg,a0
;    bsr	tx_str
    rts
rx_str_bs:
    move.w	d1,d1	;set Z flag is a0 is not 0
    beq	rx_str_loop
    move.b	#$0,-(a0)
    subi.b	#$1,d1
    move.b	#BACKSPACE,d0
    bsr	tx_char		; should output backspace char
    move.b	#SPACE,d0
    bsr	tx_char
    move.b	#BACKSPACE,d0
    bsr	tx_char
    bra	rx_str_loop



;-------------------tx longword 
tx_l:
    move.l	d0,-(sp)
    swap	d0
    andi.l	#$FFFF,d0
    bsr	tx_w
    move.l	(sp)+,d0
    andi.l	#$FFFF,d0
    bsr	tx_w
    rts

;-------------------tx word (hex)
tx_w:
    move.l	d0,-(sp)
; lsr should be here!
    ror	#8,d0
    bsr	tx_b
    move.l	(sp)+,d0
    andi.l	#$00FF,d0
    bsr	tx_b
    rts

;-------------------tx byte (hex)
tx_b:
    move.l	d0,-(sp)
    move.l	d0,-(sp)
    andi.l	#$00F0,d0
; lsr should be here
    ror	#4,d0
    addi.b	#48,d0	; adding '0'
    cmpi.b	#57,d0
    ble	tx_byte_1	; branch if less then 0xA
    addi.b	#7,d0	; 59->65,'A'
tx_byte_1:
    bsr	tx_char
    move.l	(sp)+,d0
    andi.l	#$000F,d0
    addi.b	#48,d0	; adding '0'
    cmpi.b	#57,d0
    ble	tx_byte_2	; branch if less then 0xA
    addi.b	#7,d0	; 59->65,'A'
tx_byte_2:
    bsr	tx_char
    move.l	(sp)+,d0
    rts

;------------------ TX str in A0 ; destroys A0
tx_str:
    move.l	d0,-(sp)
tx_str_loop:
    move.b	(a0)+,d0
    cmpi.b	#$0,d0
    beq	tx_str_exit
    bsr	tx_char
    bra	tx_str_loop
tx_str_exit:
    move.l	(sp)+,d0
    rts

;-------------------------------- Strings -------------------------
;    data
    even
    cnop	$,2
commands_vector:
    dc.l	f_dump
    dc.l	f_blink
    dc.l	f_bs
    dc.l	f_bf
    dc.l	f_ledon
    dc.l	f_ledoff
    dc.l	f_in
    dc.l	fuckaduck

    even

commands:
    dc.b	'DUMP',0
    dc.b	'BLINK',0
    dc.b	'BS',0
    dc.b	'BF',0
    dc.b	'ON',0
    dc.b	'OFF',0
    dc.b	'IN',0
    dc.b	'FUCK A DUCK',0
;    dc.l	#fuckaduck
    dc.b	0

; 'DUMP' command will resume from this address
    even
dumpstart:
    dc.l	0

crlfmsg:
    dc.b	CR,LF,0

errmsg:
    dc.b	$0d,$0a
    dc.b	'? err: '
    dc.b	0

hellomsg:
    dc.b	'DtZ '
    dc.b	'68kavrZ '
    dc.b	'0.00.01'
    dc.b	$0d,$0a,0

;    align 4
promptmsg:
    dc.b	$0d,$0a
    dc.b	'*'
    dc.b	0

quackmsg:
    dc.b	$0d,$0a
    dc.b	'>0',$0d,$0a,' ( )<',$0d,$0a,' _|','   '
    dc.b	'QUACK '
    dc.b	'QUACK '
    dc.b	'QUACK '
    dc.b	0

executing_msg:
    dc.b	$0d,$0a
    dc.b	'Doing ',0
;    align 4
buff:
    ds.b	100

;    dc.b	'_______'
;    dc.b	'_______'
;    dc.b	0
;    align 4



;    ds.b	8
;    ds.b	8
;    ds.b	8
;    ds.b	8



