; --------------------------- Srecord parcing --------------------
; A1 - points to buffer after 'S' 
f_s:
    bsr	srecord_checksumm
    move.b	d0,d0
    beq	srecord_chk_ok
    rts
srecord_chk_ok:
    move.b	(a1)+,d0 ; taking first char - record type
    move.b	d0,-(sp) ; pushing record type to stack
    movea	a1,a0	; calling scan_b
    bsr	scan_b		; scanning record length
    move.b	d0,d2	; moving scanned string length to d2
    bsr	tx_b
    move.b	#'*',d0
    bsr	tx_char
;    move.b	d1,d1	; setting flags - was that a error in scanning (should be none - allready checked)?
;    bne	srecord_err_and_pop
    move.b	(sp)+,d0 ; popping record type from stack
    cmpi.b	#'0',d0
    beq	srecord_ok	; just ignoring
    cmpi.b	#'1',d0
    beq	f_s1
    cmpi.b	#'2',d0
    beq	f_s2
    cmpi.b	#'3',d0
    beq	f_s3
    cmpi.b	#'5',d0
    beq	f_s5
    cmpi.b	#'7',d0
    beq	f_s7
    cmpi.b	#'8',d0
    beq	f_s8
    cmpi.b	#'9',d0
    beq	f_s9
    suba	#$1,a1	; this error happened in record type, decrementing pointer
    bra	srecord_err

; not a know s-record type
srecord_err_and_pop:
    move.b	(sp)+,d0 ; popping record type (or whatever) from stack 
srecord_err:
    movea	#srecord_err_msg,A0
    bsr	tx_str
    movea	a1,a0
    bsr	tx_str
    rts

; here A0 points to the char after S-record length
f_s1:
    bsr	scan_w
    move.l	d0,a3	; a3 will be an address to write the parced string
    bsr	tx_l
    bra	srecord_write_to_mem

    
f_s2:
    bsr		scan_24bit
    move.l	d0,a3	; a3 will be an address to write the parced string
    bsr	tx_l
    bra	srecord_write_to_mem

f_s3:
    bsr		scan_l
    move.l	d0,a3	; a3 will be an address to write the parced string
    bsr	tx_l
    bra	srecord_write_to_mem

f_s5:
f_s7:
f_s8:
f_s9:
    movea	#srecord_len_msg,a0
    bsr	tx_str
    move.b	d2,d0	; length
    bsr	tx_b
    bra	srecord_ok


srecord_write_to_mem:
    move.b	#'.',d0
    bsr	tx_char
    move.b	d2,d0
    bsr	tx_b
    move.b	#'.',d0
    bsr	tx_char

srecord_write_to_mem_loop:

    move.b	d2,d2	; any more bytes in string?
    beq	srecord_ok
    bsr	scan_b
    move.b	d0,(a3)+
    bsr	tx_b
    subi	#$1,d2
    bra	srecord_write_to_mem_loop


srecord_ok:
    movea	#srecord_ok_msg,a0
    bsr	tx_str
    rts


; --------------------------- Checksumm counting --------------------
; returns d0=0 if ok
srecord_checksumm:
    ; a1 points to record type (second byte in string
    move.l	a1,-(sp)	; storing it
    move.b	(a1)+,d0 ; record type
    move	a1,a0	; A1 now points to record len
    bsr	scan_b
    move.l	a0,a1	; for error reporting 
    move.b	d1,d1	; setting flags - was that a error in scanning?
    bne	srecord_chks_err
    move.b	d0,d4	; here be checksumm - initing with record length
    move.b	d0,d3	; counter - A3 chars
;    bsr	tx_b
    
srecord_loop:
    move.b	d3,d3	; setting flags
    beq	srecord_end
    bsr	scan_b
    move.l	a0,a1	; for error reporting 
    move.b	d1,d1	; setting flags - was that a error in scanning?
    bne	srecord_chks_err
    add.b	d0,d4
    subi	#$1,d3	; decrementing counter
    bra	srecord_loop
    

    
srecord_end:
    move.b	d4,d0	; the checksumm
    addi.b	#$1,d0	; normally, FF there; so we will return 0
    beq	srecord_end_noerr	; no error
    movea	#srecord_chks_err_msg,a0	; 'Checksumm err' msg
    bsr	tx_str
srecord_end_noerr:
    move.l	(sp)+,a1 ; popping A1
    rts

srecord_chks_err:	;some parcing error happened
    movea	#srecord_err_msg,A0
    bsr	tx_str
    movea	a1,a0	; this is the address of error
    bsr	tx_str
    move.l	(sp)+,a1 ; popping A1
    move.b	#$1,d0
    rts
; --------------------------- Done checksumm counting --------------------
    even
srecord_len_msg:
    dc.b	'Length of record: ',0
    even
srecord_err_msg:
    dc.b	'Srecord error ->',0
    even
srecord_ok_msg:
    dc.b	'Srecord ok!',CR,LF,0
srecord_chks_err_msg:
    dc.b	'Srecord checksum error',CR,LF,0
    even


    