#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#define  DTZ_PORT_FUNC
#include "main.h"

void click_clock() 
{/* rewrite it later */
 static uint8_t ledon;
// USART_PUTCH('*');
 if (ledon)
 {
  ledon = 0;
  CLK_PORT |= _BV(CLK_PIN);
 }
 else
 {
  ledon = 1;
  CLK_PORT &= ~_BV(CLK_PIN);
 }
// Int 0 leg PIND & _BV(PIN2) - DS line
}

void data_bus_to_read(void) 
{
 writing_on_bus = 0;
 DDRB = DDRB & ~0x3F ;
 DDRD = DDRD & ~0xC0 ;
 PORTB |= 0x3F;
 PORTD |= 0xC0; /* pull up for it */
}

void writebyte(unsigned char b)
{
 writing_on_bus = 1;
 DDRB = DDRB | 0x3F ;	/* Setting Data bus as output */
 DDRD = DDRD | 0xC0 ;
 PORTB = (PORTB & 0xC0) | (b & 0x3F); /* Keeping two bytes from PORTB and lower 6 bytes from b*/
 PORTD = (PORTD & 0x3F) | (b & 0xC0); /* taking lower part D from D and high 2 bits from b*/
}

void setioports() 
{
 /* Telling CLK/Blink to blink - setting it as output*/
 CLK_DDR |= _BV(CLK_PIN);
 /* As well BOOTMODE line shoud be set to output */
 BOOTMODE_DDR |= _BV(BOOTMODE_PIN);

 /* setting reset to 1 */
 RESET_PORT |= _BV(RESET_PIN);
 RESET_DDR |= _BV(RESET_PIN);
 RESET_PORT |= _BV(RESET_PIN);


 /* RD/WR line shoud be set to read and pulled up*/
 RDWR_DDR &= ~_BV(RDWR_PIN);
 RDWR_PORT |= _BV(RDWR_PIN); 

 /* A1 line shoud be set to read address bus */
 A1_DDR &= ~_BV(A1_PIN);
 A1_PORT |= _BV(A1_PIN); 

#ifdef WITH_CTS
// RTS_PORT |= _BV(RTS_PIN);
 RTS_DDR |= _BV(RTS_PIN);
 rts_up();
// RTS_PORT |= _BV(RTS_PIN);
#endif


 /* BOOTMODE line shoud be set to read and pulled up*/

/* And WR line, too */
// WR_DDR &= ~_BV(WR_PIN);
// WR_PORT |= _BV(WR_PIN); /* Pull-up for it */

 data_bus_to_read();
}


unsigned char read_data_bus() {
// writing_on_bus = 0;
// DDRB = DDRB | 0x3F ;
// DDRD = DDRD | 0xC0 ;
 data_bus_to_read(); // it should be allready
 return ((PIND & 0xC0) + (PINB & 0x3F));
}
void enter_bootmode()
{
// return;
 static const PROGMEM unsigned char bmsg[] = "\n\r*********IN A BOOT MODE*****\n\r";
 USART_PUTS_my(bmsg);
// DDRC = _BV(PC1);
 bootmode = 1;
 BOOTMODE_PORT &= ~_BV(BOOTMODE_PIN);
}

void exit_bootmode()
{
// return;
 static const PROGMEM unsigned char bmsg[] = "\n\r[Exiting bootmode]\n\r";
 bootmode = 0;
 USART_PUTS_my(bmsg);
 BOOTMODE_PORT |= _BV(BOOTMODE_PIN);
}

void reset_CPU()
{
// return;
 static const PROGMEM unsigned char bmsg[] = "\n\r*********Resetting CPU!*****\n\r";
 USART_PUTS_my(bmsg);
// DDRC = _BV(PC1);
 RESET_PORT &= ~_BV(RESET_PIN);
#ifdef DEBUG
 reset_ticks = 600;
#else
 reset_ticks = 300000;
#endif
}

void reset_forever()
{
 static const PROGMEM unsigned char bmsg[] = "\n\r***Halted***\n\r";
 USART_PUTS_my(bmsg);
 RESET_PORT &= ~_BV(RESET_PIN);
 reset_ticks = -1;
}

void release_reset_CPU()
{
// return;
 static const PROGMEM unsigned char bmsg[] = "\n\r[Released reset]\n\r";
 USART_PUTS_my(bmsg);

// RESET_DDR &= ~_BV(RESET_PIN);
 RESET_DDR |= _BV(RESET_PIN);
 RESET_PORT |= _BV(RESET_PIN);

// RESET_DDR = RESET_DDR | RESET_PIN ; // Pollup?
}

